{"title": "Optimal sub-graphical models", "book": "Advances in Neural Information Processing Systems", "page_first": 961, "page_last": 968, "abstract": null, "full_text": " Optimal sub-graphical models\n\n\n\n Mukund Narasimhan and Jeff Bilmes\n Dept. of Electrical Engineering\n University of Washington\n Seattle, WA 98195\n {mukundn,bilmes}@ee.washington.edu\n\n\n\n Abstract\n\n We investigate the problem of reducing the complexity of a graphical\n model (G, PG) by finding a subgraph H of G, chosen from a class of\n subgraphs H, such that H is optimal with respect to KL-divergence. We\n do this by first defining a decomposition tree representation for G, which\n is closely related to the junction-tree representation for G. We then give\n an algorithm which uses this representation to compute the optimal H \n H. Gavril [2] and Tarjan [3] have used graph separation properties to\n solve several combinatorial optimization problems when the size of the\n minimal separators in the graph is bounded. We present an extension of\n this technique which applies to some important choices of H even when\n the size of the minimal separators of G are arbitrarily large. In particular,\n this applies to problems such as finding an optimal subgraphical model\n over a (k - 1)-tree of a graphical model over a k-tree (for arbitrary k)\n and selecting an optimal subgraphical model with (a constant) d fewer\n edges with respect to KL-divergence can be solved in time polynomial in\n |V (G)| using this formulation.\n1 Introduction and Preliminaries\n\nThe complexity of inference in graphical models is typically exponential in some parame-\nter of the graph, such as the size of the largest clique. Therefore, it is often required to find\na subgraphical model that has lower complexity (smaller clique size) without introducing\na large error in inference results. The KL-divergence between the original probability dis-\ntribution and the probability distribution on the simplified graphical model is often used to\nmeasure the impact on inference. Existing techniques for reducing the complexity of graph-\nical models including annihilation and edge-removal [4] are greedy in nature and cannot\nmake any guarantees regarding the optimality of the solution. This problem is NP-complete\n[9] and so, in general, one cannot expect a polynomial time algorithm to find the optimal\nsolution. However, we show that when we restrict the problem to some sets of subgraphs,\nthe optimal solution can be found quite quickly using a dynamic programming algorithm\nin time polynomial in the tree-width of the graph.\n\n\n1.1 Notation and Terminology\n\nA graph G = (V, E) is said to be triangulated if every cycle of length greater than 3\nhas a chord. A clique of G is a non-empty set S V such that {a, b} E for all\n\n This work was supported by NSF grant IIS-0093430 and an Intel Corporation Grant.\n\n\f\n {b, c, d} {c, f, g}\n d\n {b, c} {f, c}\n {c, e}\n {b, e, c} {e, c, f }\n b c g\n {b, e}\n\n\n {a, b, e}\n a e f\n\n Figure 1: A triangulated graph G and a junction-tree for G\n\n\n\na, b S. A clique S is maximal if S is not properly contained in another clique. If\n and are non-adjacent vertices of G then a set of vertices S V \\ {, } is called\nan (, )-separator if and are in distinct components of G[V \\ S]. S is a minimal\n(, )-separator if no proper subset of S is an (, )-separator. S is said to be a minimal\nseparator if S is a minimal (, )-separator for some non adjacent a, b V . If T =\n(K, S) is a junction-tree for G (see [7]), then the nodes K of T correspond to the maximal-\ncliques of G, while the links S correspond to minimal separators of G (We reserve the\nterms vertices/edges for elements of G, and nodes/links for the elements of T ). If G is\ntriangulated, then the number of maximal cliques is at most |V |. For example, in the graph\nG shown in Figure 1, K = {{b, c, d} , {a, b, e} , {b, e, c} , {e, c, f } , {c, f, g}}. The links\nS of T correspond to minimal-separators of G in the following way. If ViVj S (where\nVi, Vj K and hence are cliques of G), then Vi Vj = . We label each edge ViVj S\nwith the set Vij = Vi Vj, which is a non-empty complete separator in G. The removal of\nany link ViVj S disconnects T into two subtrees which we denote T (i) and T (j) (chosen\nso that T (i) contains Vi). We will let K(i) be the nodes of T (i), and V (i) = V K(i)V be\nthe set of vertices corresponding to the subtree T (i). The junction tree property ensures that\nV (i) V (j) = Vi Vj = Vij. We will let G(i) be the subgraph induced by V (i).\n\nA graphical model is a pair (G, P ) where P is the joint probability distribution for random\nvariables X1, X2, . . . , Xn, and G is a graph with vertex set V (G) = {X1, X2, . . . , Xn}\nsuch that the separators in G imply conditional independencies in P (so P factors according\nto G). If G is triangulated, then the junction-tree algorithm can be used for exact inference\nin the probability distribution P . The complexity of this algorithm grows with the treewidth\nof G (which is one less than the size of the largest clique in G when G is triangulated). The\ngrowth is exponential when P is a discrete probability distribution, thus rendering exact\ninference for graphs with large treewidth impractical. Therefore, we seek another graphical\nmodel (H, PH ) which allows tractable inference (so H should have lower treewidth than\nG has). The general problem of finding a graphical model of tree-width at most k so as\nto minimize the KL-divergence from a specified probability distribution is NP complete\nfor general k ([9]) However, it is known that this problem is solvable in polynomial time\n(in |V (G)|) for some special cases cases (such as when G has bounded treewidth or when\nk = 1 [1]). If (G, PG) and (H, PH ) are graphical models, then we say that (H, PH ) is a\nsubgraphical model of (G, PG) if H is a spanning subgraph of G. Note in particular that\nseparators in G are separators in H, and hence (G, PH ) is also a graphical model.\n\n\n2 Graph Decompositions and Divide-and-Conquer Algorithms\n\nFor the remainder of the paper, we will be assuming that G = (V, E) is some triangulated\ngraph, with junction tree T = (K, S). As observed above, if ViVj S, then the removal\n\n\f\n {b, c, d} {c, f, g}\nd\n {b, c} {f, c}\n\n {b, e, c} {e, c, f }\nb c c g\n {b, e}\n\n\n {a, b, e}\na e e f\n\nFigure 2: The graphs G(i), G(j) and junction-trees T (i) and T (j) resulting from the removal\nof the link Vij = {c, e}\n\n\n\nof Vij = Vi Vj disconnects G into two (vertex-induced) subgraphs G(i) and G(j) which\nare both triangulated, with junction-trees T (i) and T (j) respectively. We can recursively\ndecompose each of G(i) and G(j) into smaller and smaller subgraphs till the resulting sub-\ngraphs are cliques. When the size of all the minimal separators are bounded, we may use\nthese decompositions to easily solve problems that are hard in general. For example, in [5]\nit is shown that NP-complete problems like vertex coloring, and finding maximum inde-\npendent sets can be solved in polynomial time on graphs with bounded tree-width (which\nare equivalent to spanning graphs with bounded size separators). We will be interested in\nfinding (triangulated) subgraphs of G that satisfy some conditions, such as a bound on the\nnumber of edges, or a bound on the tree-width and which optimize separable objective\nfunctions (described in Section 2)\n\nOne reason why problems such as this can often be solved easily when the tree-width of\nG is bounded by some constant is this : If Vij is a separator decomposing G into G(i)\nand G(j), then a divide-and-conquer approach would suggest that we try and find optimal\nsubgraphs of G(i) and G(j) and then splice the two together to get an optimal subgraph of\nG. There are two issues with this approach. First, the optimal subgraphs of G(i) and G(j)\nneed not necessarily match up on Vij, the set of common vertices. Second, even if the two\nsubgraphs agree on the set of common vertices, the graph resulting from splicing the two\nsubgraphs together need not be triangulated (which could happen even if the two subgraphs\nindividually are triangulated). To rectify the situation, we can do the following. We parti-\ntion the set of subgraphs of G(i) and G(j) into classes, so that any subgraph of G(i) and any\nsubgraph G(j) corresponding to the same class are compatible in the sense that they match\nup on their intersection namely Vij, and so that by splicing the two subgraphs together, we\nget a subgraph of G which is acceptable (and in particular is triangulated). Then given op-\ntimal subgraphs of both G(i) and G(j) corresponding to each class, we can enumerate over\nall the classes and pick the best one. Of course, to ensure that we do not repeatedly solve\nthe same problem, we need to work bottom-up (a.k.a dynamic programming) or memoize\nour solutions. This procedure can be carried out in polynomial (in |V |) time as long as\nwe have only a polynomial number of classes. Now, if we have a polynomial number of\nclasses, these classes need not actually be a partition of all the acceptable subgraphs, though\nthe union of the classes must cover all acceptable subgraphs (so the same subgraph can be\ncontained in more than one class). For our application, every class can be thought of to be\nthe set of subgraphs that satisfy some constraint, and we need to pick a polynomial number\nof constraints that cover all possibilities. The bound on the tree-width helps us here. If\n|V )\n ij | = k, then in any subgraph H of G, H [Vij ] must be one of the 2(k\n 2 possible subgraphs\nof G[V )\n ij ]. So, if k is sufficiently small (so 2(k\n 2 is bounded by some polynomial in |V |),\n\n\f\nthen this procedure results in a polynomial time algorithm. In this paper, we show that in\nsome cases we can characterize the space H so that we still have a polynomial number of\nconstraints even when the tree-width of G is not bounded by a small constant.\n\n2.1 Separable objective functions\n\nFor cases where exact inference in the graphical model (G, PG) is intractable, it is natural to\ntry to find a subgraphical model (H, PH ) such that D(PG PH ) is minimized, and inference\nusing H is tractable. We will denote by H the set of subgraphs of G that are tractable for\ninference. For example, this set could be the set of subgraphs of G with treewidth one less\nthan the treewidth of G, or perhaps the set of subgraphs of G with at d fewer edges. For a\nspecified subgraph H of G, there is a unique probability distribution PH factoring over H\nthat minimizes D(PG PH ). Hence, finding a optimal subgraphical model is equivalent to\nfinding a subgraph H for which D(PG PH ) is minimized. If Vij is a separator of G, we\nwill attempt to find optimal subgraphs of G by finding optimal subgraphs of G(i) and G(j)\nand splicing them together. However, to do this, we need to ensure that the objective criteria\nalso decomposes along the separator Vij. Suppose that H is any triangulated subgraph of G.\nLet PG(i) and PG(j) be the (marginalized) distributions of PG on V (i) and V (j) respectively,\nand PH(i) and PH(j) be the (marginalized) distributions of the distribution PH on V (i) and\nV (j) where H(i) = H[V (i)] and H(j) = H[V (j)], The following result assures us that the\nKL-divergence also factors according to the separator Vij.\nLemma 1. Suppose that (G, PG) is a graphical model, H is a triangulated subgraph of\nG, and PH factors over H. Then D(PG PH ) = D(PG(i) PH(i)) + D(PG(j) PH(j)) -\nD(PG[Vij] PH[Vij]).\n\nProof. Since H is a subgraph of G, and Vij is a separator of G, Vij must also be a sepa-\n P\nrator of H. Therefore, P H(i) ({Xv }vV (i) )PH(j) ({Xv }vV (j) )\n H {Xv} = . The result\n vV PH[V )\n ij ] ({Xv }vVij\nfollows immediately.\n\n\nTherefore, there is hope that we can reduce our our original problem of finding an optimal\nsubgraph H H as one of finding subgraphs of H (i) G(i) and H(j) G(j) that are\ncompatible, in the sense that they match up on the overlap Vij, and for which D(PG PH )\nis minimized. Throughout this paper, for the sake of concreteness, we will assume that\nthe objective criterion is to minimize the KL-divergence. However, all the results can\nbe extended to other objective functions, as long as they \"separate\" in the sense that for\nany separator, the objective function is the sum of the objective functions of the two parts,\npossibly modulo some correction factor which is purely a function of the separator. Another\nexample might be the complexity r(H) of representing the graphical model H. A very\nnatural representation satisfies r(G) = r(G(i)) + r(G(j)) if G has a separator G(i) G(j).\nTherefore, the representation cost reduction would satisfy r(G) - r(H) = (r(G(i)) -\nr(H(i))) + (r(G(j)) - r(H(j))), and so also factors according to the separators. Finally\nnote that any linear combinations of such separable functions is also separable, and so this\ntechnique could also be used to determine tradeoffs (representation cost vs. KL-divergence\nloss for example). In Section 4 we discuss some issues regarding computing this function.\n\n\n2.2 Decompositions and decomposition trees\n\nFor the algorithms considered in this paper, we will be mostly interested in the decompo-\nsitions that are specified by the junction tree, and we will represent these decompositions\nby a rooted tree called a decomposition tree. This representation was introduced in [2, 3],\nand is similar in spirit to Darwiche's dtrees [6] which specify decompositions of directed\nacyclic graphs. In this section and the next, we show how a decomposition tree for a graph\nmay be constructed, and show how it is used to solve a number of optimization problems.\n\n\f\n abd; ce; gf\n\n a; be; cd\n\n e; cf ; g\n d; bc; e\n\n\n abe dbc ebc cef cf g\n\n\n Figure 3: The separator tree corresponding to Figure 1\n\n\n\nA decomposition tree for G is a rooted tree whose vertices correspond to separators and\ncliques of G. We describe the construction of the decomposition tree in terms of a junction-\ntree T = (K, S) for G. The interior nodes of the decomposition tree R(T ) correspond to\nS (the links of T and hence the minimal separators of G). The leaf or terminal nodes\nrepresent the elements of K (the nodes of T and hence the maximal cliques of G). R(T )\ncan be recursively constructed from T as follows : If T consists of just one node K, (and\nhence no edges), then R consists of just one node, which is given the label K as well. If\nhowever, T has more than one node, then T must contain at least one link. To begin, let\nViVj S be any link in T . Then removal of the link ViVj results in two disjoint junction-\ntrees T (i) and T (j). We label the root of R by the decomposition (V (i); Vij; V (j)). The rest\nof R is recursively built by successively picking links of T (i) and T (j) (decompositions of\nG(i) and G(j)) to form the interior nodes of R. The effect of this procedure on the junction\ntree of Figure 1 is shown in Figure 3, where the decomposition associated with the interior\nnodes is shown inside the nodes. Let M be the set of all nodes of R(T ). For any interior\nnode M induced by the the link ViVj S of T , then we will let M (i) and M (j) represent\nthe left and right children of M , and R(i) and R(j) be the left and right trees below M .\n\n\n3 Finding optimal subgraphical models\n\n3.1 Optimal sub (k - 1)-trees of k-trees\n\nSuppose that G is a k-tree. A sub (k - 1)-tree of G is a subgraph H of G that is (k - 1)-\ntree. Now, if Vij is any minimal separator of G, then both G(i) and G(j) are k-trees on\nvertex sets V (i) and V (j) respectively. It is clear that the induced subgraphs H[V (i)] and\nH[V (j)] are subgraphs of G(i) and G(j) and are partial (k - 1)-trees. We will be interested\nin finding sub (k - 1)-trees of k trees and this problem is trivial by the result of [1] when\nk = 2. Therefore, we assume that k 3. The following result characterizes the various\npossibilities for H[Vij] in this case.\n\nLemma 2. Suppose that G is a k-tree, and S = Vij is a minimal separator of G corre-\nsponding to the link ij of the junction-tree T . In any (k - 1)-tree H G either\n\n 1. There is a u S such that u is not connected to vertices in both V (i) \\ S and\n V (j) \\ S. Then S \\ {u} is a minimal separator in H and hence is complete.\n\n 2. Every vertex in S is connected to vertices in both V (i) \\S and V (j) \\S. Then there\n are vertices {x, y} S such that the edge H[S] is missing only the edge {x, y}.\n Further either H[V (i)] or H[V (j)] does not contain a unchorded x-y path.\n\n\f\nProof. We consider two possibilities. In the first, there is some vertex u S such that u is\nnot connected to vertices in both V (i) \\ S and V (j)\\. Since the removal of S disconnects G,\nthe removal of S must also disconnect H. Therefore, S must contain a minimal separator\nof H. Since H is a (k - 1)-tree, all minimal separators of H must contain k - 1 vertices\nwhich must therefore be S \\{u}. This corresponds to case (1) above. Clearly this possiblity\ncan occur.\n\nIf there is no such u S, then every vertex in S is connected to vertices in both V (i) \\ S\nand V (j) \\ S. If x S is connected to some yi V (i) \\ S and yj V (j) \\ S, then x is\ncontained in every minimal yi/yj separator (see [5]). Therefore, every vertex in S is part of\na minimal separator. Since each minimal separator contains k - 1 vertices, there must be at\nleast two distinct minimum separators contained in S. Let Sx = S \\ {x} and Sy = S \\ {y}\nbe two distinct minimal separators. We claim that H[S] contains all edges except the edge\n{x, y}. To see this, note that if z, w S, with z = w and {z, w} = {x, y} (as sets),\nthen either {z, w} Sy or {z, w} Sx. Since both Sx and Sy are complete in H, this\nedge must be present in H. The edge {x, y} is not present in H[S] because all minimal\nseparators in H must be of size k - 1. Further, if both V (i) and V (j) contain an unchorded\npath between x and y, then by joining the two paths at x and y, we get a unchorded cycle\nin H which contradicts the fact that H is triangulated.\n\n\n\nTherefore, we may associate k 2 + 2 k constraints with each separator V\n 2 ij of G as\nfollows. There are k possible constraints corresponding to case (1) above (one for each\nchoice of x), and k 2 choices corresponding to case (2) above. This is because for each\n 2\npair {x, y} corresponding to the missing edge, we have either V (i) contains no unchorded\nxy paths or V (j) contains no unchorded xy paths. More explicitly, we can encode the set\nof constraints CM associated with each separator S corresponding to an interior node M of\nthe decomposition tree as follows: CM = { (x, y, s) : x S, y S, s {i, j}}. If y = x,\nthen this corresponds to case (1) of the above lemma. If s = i, then x is connected only to\nH(i) and if s = j, then x is connected only to H(j). If y = x, then this corresponds to case\n(2) in the above lemma. If s = i, then H (i) does not contain any unchorded path between\nx and y, and there is no constraint on H(j). Similarly if s = j, then H(j) does not contain\nany unchorded path between x and y, and there is no constraint on H (i).\n\nNow suppose that H(i) and H(j) are triangulated subgraphs of G(i) and G(j) respectively,\nthen it is clear that if H(i) and H(j) both satisfy the same constraint they must match up\non the common vertices Vij. Therefore to splice together two solutions corresponding to\nthe same constraint, we only need to check that the graph obtained by splicing the graphs\nis triangulated.\n\nLemma 3. Suppose that H(i) and H(j) are triangulated subgraphs of G(i) and G(j) re-\nspectively such that both of them satisfy the same constraint as described above. Then the\ngraph H obtained by splicing H(i) and H(j) together is triangulated.\n\n\nProof. Suppose that both H(i) and H(j) are both triangulated and both satisfy the same\nconstraint. If both H(i) and H(j) satisfy the same constraint corresponding to case (1)\nin Lemma 2 and H has an unchorded cycle, then this cycle must involve elements of both\nH(i) and H(j). Therefore, there must be two vertices of S \\{u} on the cycle, and hence this\ncycle has a chord as S \\ {u} is complete. This contradiction shows that H is triangulated.\nSo assume that both of them satisfy the constraint corresponding to case (2) of Lemma 2.\nThen if H is not triangulated, there must be a t-cycle (for t 4) with no chord. Now, since\n{x, y} is the only missing edge of S in H, and because H (i) and H(j) are individually\ntriangulated, the cycle must contain x, y and vertices of both V (i) \\ S and V (j) \\ S. We\n\n\f\nmay split this unchorded cycle into two unchorded paths, one contained in V (i) and one in\nV (j) thus violating our assumption that both H(i) and H(j) satisfy the same constraint.\n\n\nIf |S| = k, then there are 2k + 2 k O(k2) O(n2). We can use a divide and conquer\n 2\nstrategy to find the optimal sub (k - 1) tree once we have taken care of the base case, where\nG is just a single clique (of k + 1) elements. However, for this case, it is easily checked that\nany subgraph of G obtained by deleting exactly one edge results in a (k - 1) tree, and every\nsub (k-1)-tree results from this operation. Therefore, the optimal (k-1)-tree can be found\nusing Algorithm 1, and in this case, the complexity of Algorithm 1 is O(n(k + 1)2). This\nprocedure can be generalized to find the optimal sub (k - d)- tree for any fixed d. However,\nthe number of constraints grows exponentially with d (though it is still polynomial in n).\nTherefore for small, fixed values of d, we can compute the optimal sub (k - d)-tree of G.\nWhile we can compute (k - d)-trees of G by first going from a k tree to a (k - 1) tree, then\nfrom a (k - 1)-tree to a (k - 2)-tree, and so on in a greedy fashion, this will not be optimal\nin general. However, this might be a good algorithm to try when d is large.\n\n\n3.2 Optimal triangulated subgraphs with |E(G)| - d edges\n\nSuppose that we are interested in a (triangulated) subgraph of G that contains d fewer edges\nthat G does. That is, we want to find an optimal subgraph H G such that |E(H)| =\n|E(G)| - d. Note that by the result of [4] there is always a triangulated subgraph with d\nfewer edges (if d < |E(G)|). Two possibilities for finding such an optimal subgraph are\n\n 1. Use the procedure described in [4]. This is a greedy procedure which works in\n d steps by deleting an edge at each step. At each state, the edge is picked from\n the set of edges whose deletion leaves a triangulated graph. Then the edge which\n causes the least increase in KL-divergence is picked at each stage.\n\n 2. For each possible subset A of E(G) of size d, whose deletion leaves a triangulated\n graph, compute the KL divergence using the formula above, and then pick the\n optimal one. Since there are |E(G)| such sets, this can be done in polynomial\n d\n time (in |V (G)|) when d is a constant.\n\nThe first greedy algorithm is not guaranteed to yield the optimal solution. The second takes\ntime that is O(n2d). Now, let us solve this problem using the framework we've described.\n\nLet H be the set of subgraphs of G which may be obtained by deletion of d\nedges. For each M = ij M corresponding to the separator Vij, let CM =\n\n (l, r, c, s, A) : l + r - c = d, s a d bit string, A E(G[Vij]) . The constraint repre-\n c\n\nsented by (l, r, c, A) is this : A is a set of d edges of G[Vij] that are missing in H, l edges\nare missing from the left subgraph, and r edges are missing from the right subgraph. c rep-\nresents the double count, and so is subtracted from the total. If k is the size of the largest\n )\nclique, then the total number of such constraints is bounded by 2d 2d (k2 O(k2d)\n d\nwhich could be better than O(n2d) and is polynomial in |V | when d is constant. See [10]\nfor additional details.\n\n\n4 Conclusions\n\nAlgorithm 1 will compute the optimal H H for the two examples discussed above and\nis polynomial (for fixed constant d) even if k is O(n). In [10] a generalization is presented\nwhich will allow finding the optimal solution for other classes of subgraphical models.\nNow, we assume an oracle model for computing KL-divergences of probability distribu-\ntions on vertex sets of cliques. It is clear that these KL-divergences can be computed\n\n\f\nR separator-tree for G;\nfor each vertex M of R in order of increasing height (bottom up) do\n for each constraint cM of M do\n if M is an interior vertex of R corresponding to edge ij of the junction tree then\n Let Ml and Mr be the left and right children of M ;\n Pick constraint cl CM compatible with c\n l M to minimize table[Ml, cl];\n Pick constraint cr CM compatible with c\n r M to minimize table[Mr , cr ];\n loss D(PG[M ] PH [M ]);\n table[M, cM ] table[Ml, cl] + table[Mr, cr] - loss;\n\n else\n table[M, cM ] D(PG[M ] PH [M ]);\n\n end\n end\nend\n\n Algorithm 1: Finding optimal set of constraints\n\n\n\nefficiently for distributions like Gaussians, but for discrete distributions this may not be\npossible when k is large. However even in this case this algorithm will result in only\npolynomial calls to the oracle. The standard algorithm [3] which is exponential in the\ntreewidth will make O(2k) calls to this oracle. Therefore, when the cost of computing the\nKL-divergence is large, this algorithm becomes even more attractive as it results in expo-\nnential speedup over the standard algorithm. Alternatively, if we can compute approximate\nKL-divergences, or approximately optimal solutions, then we can compute an approximate\nsolution by using the same algorithm.\n\n\nReferences\n\n [1] C. Chow and C. Liu, \"Approximating discrete probability distributions with depen-\n dence trees\", IEEE Transactions on Information Theory, v. 14, 1968, Pages 462467.\n\n [2] F. Gavril, \"Algorithms on clique separable graphs\", Discrete Mathematics v. 9 (1977),\n pp. 159165.\n\n [3] R. E. Tarjan. \"Decomposition by Clique Separators\", Discrete Mathematics, v. 55\n (1985), pp. 221232.\n\n [4] U. Kjaerulff. \"Reduction of computational complexity in Bayesian networks through\n removal of weak dependencies\", Proceedings of the Tenth Annual Conference on\n Uncertainty in Artificial Intelligence, pp. 374382, 1994.\n\n [5] T. Kloks, \"Treewidth: Computations and Approximations\", Springer-Verlag, 1994.\n\n [6] A. Darwiche and M. Hopkins. \"Using recursive decomposition to construct elimina-\n tion orders, jointrees and dtrees\", Technical Report D-122, Computer Science Dept.,\n UCLA.\n\n [7] S. Lauritzen. \"Graphical Models\", Oxford University Press, Oxford, 1996.\n\n [8] T. A. McKee and F. R. McMorris. \"Topics in Intersection Graph Theory\", SIAM\n Monographs on Discrete Mathematics and Applications, 1999.\n\n [9] D. Karger and N. Srebro. \"Learning Markov networks: Maximum bounded tree-width\n graphs.\" In Symposium on Discrete Algorithms, 2001, Pages 391-401.\n\n[10] M. Narasimhan and J. Bilmes. \"Optimization on separator-clique trees.\", Technical\n report UWEETR 2004-10, June 2004.\n\n\f\n", "award": [], "sourceid": 2682, "authors": [{"given_name": "Mukund", "family_name": "Narasimhan", "institution": null}, {"given_name": "Jeff", "family_name": "Bilmes", "institution": null}]}